# Define your item pipelines here
#
# Don't forget to add your pipeline to the ITEM_PIPELINES setting
# See: https://docs.scrapy.org/en/latest/topics/item-pipeline.html


# useful for handling different item types with a single interface
from itemadapter import ItemAdapter

import re
import requests
import os
from PIL import Image
from io import BytesIO
from pathlib import Path
class ShonenmagazinePipeline:
    # 自定义管道下载图片
    def process_item(self, item, spider):
        print('进入管道，处理数据ing~')
        # 保存路径
        path1 = str(re.sub(r"[\/\\\:\*\?\"\<\>\|]", '', item['comic_name']))
        path2 = str(re.sub(r"[\/\\\:\*\?\"\<\>\|]", '', item['chapter_name']))
        pathname = "./comics/" + path1 + "/" + path2 + "/"
        # 如果路径不存在则创建
        dir = Path(pathname)
        if dir.exists() == False:
            os.makedirs(pathname)
        # 图片名称
        imgname = str(abs(item['page_num'])) + '_' + path2 + '.jpg'

        # 判断图片是否存在，存在则不再保存
        imgexist = Path(pathname + imgname)
        if imgexist.exists() == False:
            # 获取图片资源内容
            response = requests.get(item['image_urls'])
            image = Image.open(BytesIO(response.content))
            # 保存到本地
            image.save(pathname + imgname)
            print('保存成功，路径：'+ pathname + imgname)
        else:
            print("已存在："+ pathname + imgname)
        return item