import scrapy
from shonenmagazine.items import ShonenmagazineItem
import json

class DetailSpider(scrapy.Spider):
    name = 'detail'
    #start_urls = ['https://pocket.shonenmagazine.com/episode/13933686331704284683']

    # 初始化
    def __init__(self, start_urls=None,crawl_mode=False, *args, **kwargs):
        super(DetailSpider, self).__init__(*args, **kwargs)
        self.start_urls = start_urls.split(",")
        self.crawl_mode = crawl_mode
        print("初始化，待爬取链接：")
        print(self.start_urls)

    # 开始请求链接    !!!坑 这里的发起请求要注意，callback如果是self.psrse，会报错，self.parse可不填因为是默认的
    # def start_requests(self):
    #     # 请求地址
    #     for url in self.start_urls:
    #         print("请求链接：" + url)
    #         yield scrapy.Request(url, callback=self.parse)

    def parse(self, response):
        print("————取得页面响应数据")
        # 获取图片json数据
        text = response.css("#episode-json::attr(data-value)").get()
        jsondata = json.loads(text)
        comic_name = jsondata['readableProduct']['series']['title']
        chapter_name = jsondata['readableProduct']['title']
        print('正在爬取：' + comic_name + '/' + chapter_name)

        page_num = 0
        if jsondata['readableProduct']['isPublic'] == True:
            print('章节是公开的，正在爬取：' + comic_name + '/' + chapter_name)
            if 'pages' in jsondata['readableProduct']['pageStructure']:
                print('找到图片，正在爬取：' + comic_name + '/' + chapter_name)
                picpages = jsondata['readableProduct']['pageStructure']['pages']
                for each in picpages:
                    if each['type'] == 'main':
                        item = ShonenmagazineItem()
                        item['image_urls'] = each['src']
                        item['comic_name'] = comic_name
                        item['chapter_name'] = chapter_name
                        page_num += 1
                        item['page_num'] = page_num
                        yield item

            else:
                print("爬取结束，没有找到图片：" + comic_name + '/' + chapter_name)
        else:
                print("章节不是公开的，爬取结束：" + comic_name + '/' + chapter_name)

        # 判断是否有下一章节
        nextpage = jsondata['readableProduct']['nextReadableProductUri']
        # 如果选择自动爬取下一章节
        if self.crawl_mode == True:
            print('——自动爬取下一章模式')
            if nextpage is not None:
                print('即将爬取下一章节：' + nextpage)
                yield scrapy.Request(url=nextpage,headers={
                  'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
                  'Accept-Language': 'en',
                  'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/84.0.4147.105 Safari/537.36',
                  'Referer': response.url
                })
            else:
                print("没找到下一章节，爬取结束。")
        else:
            print("爬取结束。")